# JENGINE v0.6.3

JEngine is a **streamlined** and **easy-to-use** framework designed for **Unity Programmers** which contains **powerful features**, beginners can **start up quickly and making hot update-able games easily**



![topLanguage](https://img.shields.io/github/languages/top/JasonXuDeveloper/JEngine)
![size](https://img.shields.io/github/languages/code-size/JasonXuDeveloper/JEngine)
![issue](https://img.shields.io/github/issues/JasonXuDeveloper/JEngine)
![license](https://img.shields.io/github/license/JasonXuDeveloper/JEngine)
![last](https://img.shields.io/github/last-commit/JasonXuDeveloper/JEngine)
[![FOSSA Status](https://app.fossa.com/api/projects/git%2Bgithub.com%2FJasonXuDeveloper%2FJEngine.svg?type=shield)](https://app.fossa.com/projects/git%2Bgithub.com%2FJasonXuDeveloper%2FJEngine?ref=badge_shield)



> QQ Group ID: [921271552](https://jq.qq.com/?_wv=1027&k=cF4hODjW)

[中文文档](README.md)

![banner](https://s1.ax1x.com/2020/10/09/0rtUL4.png)

  ## About JEngine (Chinese)

| Theme                                | Location                                                     |
| ------------------------------------ | ------------------------------------------------------------ |
| JEngine v0.6直播回放                 | [点击跳转](https://www.bilibili.com/video/BV1My4y1B7FL/)     |
| JEngine v0.6功能一览                 | [点击跳转](https://www.bilibili.com/video/BV1Yv411j7wS/)     |
| 框架文档：短时间快速精通框架必看     | [点击跳转](https://xgamedev.uoyou.com/)                      |
| 知乎文章：JEngine介绍                | [点击跳转](https://zhuanlan.zhihu.com/p/218105381)           |
| 知乎文章：JEngine热更DLL内存加密方案 | [点击跳转](https://zhuanlan.zhihu.com/p/356693738)           |
| 项目原地址                           | [GitHub地址](https://github.com/JasonXuDeveloper/JEngine)    |
| 国内快速下载地址                     | [Gitee跳转](https://gitee.com/JasonXuDeveloper/JEngine)      |
| QQ群                                 | [点击加入](https://jq.qq.com/?_wv=1027&k=cF4hODjW)https://jq.qq.com/?_wv=1027&k=cF4hODjW) |

  ## JEngine Practice

| 主题                                                         | 地址                                                      |
| ------------------------------------------------------------ | --------------------------------------------------------- |
| 【Unity x JEngine 开发可热更爆款小游戏】第一集（系列介绍及游戏策划） | [点击跳转](https://www.bilibili.com/video/BV1sV41117ka/)  |
| 【Unity x JEngine 开发可热更爆款小游戏】第二集（构建项目及界面设计） | [点击跳转](https://www.bilibili.com/video/BV1m54y117vz/)  |
| 【Unity x JEngine 开发可热更爆款小游戏】第三集（场景界面设计） | [点击跳转](https://www.bilibili.com/video/BV1sk4y1C7b5/)  |
| 【Unity x JEngine 开发可热更爆款小游戏】第四集（界面设计及代码开发） | [点击跳转](https://www.bilibili.com/video/BV1hv411y7iC/)  |
| 【Unity x JEngine 开发可热更爆款小游戏】第五集（首页UI代码开发） | [点击跳转](https://www.bilibili.com/video/BV1ZT4y1c7t7/)  |
| 【Unity x JEngine 开发可热更爆款小游戏】第六集（Bug修复+代码开发+音乐配置） | [点击跳转](https://www.bilibili.com/video/BV1bi4y1E7e7/)  |
| 【Unity x JEngine 开发可热更爆款小游戏】第七集（关卡设计+编辑器开发+数据生成） | [点击跳转](https://www.bilibili.com/video/BV1sv411y7gF/)  |
| 【Unity x JEngine 开发可热更爆款小游戏】第八集（关卡读取+界面生成） | [点击跳转](https://www.bilibili.com/video/BV15f4y1B7oQ/)  |
| 【Unity x JEngine 开发可热更爆款小游戏】第九集（关卡生成+按钮事件+游戏管理类） | [点击跳转 ](https://www.bilibili.com/video/BV1zp4y1Y7cF/) |





## Stargazers over time

[![Stargazers over time](https://starchart.cc/JasonXuDeveloper/JEngine.svg)](https://starchart.cc/JasonXuDeveloper/JEngine)

## Why JEngine?

JEngine has its aim to support game developers with **streamlined, pretty and high-performance features**, and can help developers **make games easier**.

There is no **Unity hot update frameworks** on Github that is **easier** to learn and to fully run through in short term **than JEngine**.

If you are a **fast learner**, learning JEngine and try hot update by yourself **might only takes a few minutes to a few hours**, with JEngine, you **don't need to learn any piece of code**, just write you game logic codes and edit your scenes, with the workflow JEngine provided, **your game is now hot updateable**!

At the same time, if you **have an old project which wants to hot update using JEngine**, it usually **takes a month**, and **80% of you code doesn't need any changes**, **15% of you code** might **need optimization**, and there is only **5% of you code need some changes in case of some accidents.** On the other hand, if you love using **MonoBehaviours** and love **drag'n'drop** those scripts **to inspector**, **JEngine provides a solution** for dragging hot update scripts and dropping them to a gameObject (as it is **usually unsupported** due to they ae not in the unity project and can not compile by unity)!

**JEngine** has **full documentations**, and is **always up to date**, if there is any **issue**, it **will be fixed by the developer usually in 3 days,** this framework **has been used in many different commercial projects**, no neeed to worry about **quality, performance, or efficiency**!

**If JEngine helps you, please give JEngine a star!**



## v0.6.3 Latest Features

- **Implemented** ```[System.Serializable]``` when generating **c# from proto**
- **Changed** ClassBind default to **active after**
- **Enhanced** the precision for **JFloat**
- **Enhanced** unity project which no longer depends JBehaviour from HotUpdate Solution
- **NEW** JEvent + Event Demo



[Click here to see all version updates](CHANGE.md)



## JEngine Hot Update Logics

![flowchart](https://s1.ax1x.com/2020/07/14/Uthp6A.png)

## Recommend Repositories

- [XAsset](https://github.com/xasset/xasset) - A more streamlined, efficient and secure Unity Resource Management Solution for you.
- [IFramework](https://github.com/OnClick9927/IFramework) - Simple Unity Tools
- [QFramework](https://github.com/liangxiegame/QFramework) - Your first K.I.S.S Unity 3D Framework.
